Magellan Linux

Diff of /trunk/mage/usr/lib/mage/smage2.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 597 by niro, Mon Nov 5 16:47:10 2007 UTC revision 1571 by niro, Wed Dec 28 10:30:50 2011 UTC
# Line 1  Line 1 
1  #!/bin/bash  #!/bin/bash
2    # $Id$
3    
4  # compiles/installs .smage2 source install scripts  # compiles/installs .smage2 source install scripts
5  # needs pkgbuild_dir (mage)  # needs pkgbuild_dir (mage)
6    
7  # SMAGE2  # TODO: record dynlib, gz | xz database
 # $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.59 2007-11-05 16:47:10 niro Exp $  
8    
 #01.10.2004  
 # added ccache support  
 # added distcc support  
9    
10  # set default user mage.rc  # set default user mage.rc
11  : ${MAGERC="/etc/mage.rc"}  : ${MAGERC="/etc/mage.rc"}
# Line 50  export LC_ALL=C Line 47  export LC_ALL=C
47    
48  source /etc/mage.rc.global  source /etc/mage.rc.global
49  source ${MAGERC}  source ${MAGERC}
50    source ${MLIBDIR}/mage4.functions.sh
51    
52  # set PKGDIR and BUILDDIR and BINDIR to MROOT  # set PKGDIR and BUILDDIR and BINDIR to MROOT
53  if [[ -n ${MROOT} ]]  if [[ -n ${MROOT} ]]
# Line 59  then Line 57  then
57   export BINDIR=${MROOT}/${BINDIR}   export BINDIR=${MROOT}/${BINDIR}
58  fi  fi
59    
60    # sources the smage file and uses state from distribution file if exist
61    # may helpful for repository support later on
62    smagesource()
63    {
64     local file="$1"
65     local mystate
66     local mycodename
67    
68     source ${file}
69    
70     [[ -n ${STATE} ]] && mystate="${STATE}"
71    
72     # do not overide if local state was broken or disabled!
73     case ${STATE} in
74     broken) return ;;
75     disabled) return ;;
76     esac
77    
78     if [ -f ${SMAGESCRIPTSDIR}/distribution ]
79     then
80     source ${SMAGESCRIPTSDIR}/distribution
81     [[ -n ${STATE} ]] && mystate="${STATE}"
82     fi
83     # now switch state and export it
84     STATE="${mystate}"
85    }
86    
87  showversion()  showversion()
88  {  {
89   echo -en "Magellan Source Install v${SMAGEVERSION} "   echo -en "Magellan Source Install v${SMAGEVERSION} "
# Line 73  die() Line 98  die()
98   exit 1   exit 1
99  }  }
100    
101    die_pipestatus()
102    {
103     # the status change if we do any parameter declarations!!
104     # dont do this anymore, keep this in mind!
105     #
106     # local pos="$1"
107     # local comment="$2"
108     #
109     # [ ${PIPESTATUS[${pos}]} -ne 0 ] && die "${comment}"
110     #
111     [ ${PIPESTATUS[$1]} -ne 0 ] && die "$2"
112    }
113    
114  xtitle()  xtitle()
115  {  {
116   if [[ ${TERM} = xterm ]]   if [[ ${TERM} = xterm ]]
# Line 140  download_sources() Line 178  download_sources()
178   local DB_MD5_SUM_FILE="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"   local DB_MD5_SUM_FILE="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"
179   local FETCHING   local FETCHING
180   local i mirror   local i mirror
181     local wget_opts
182    
183     # filter wget command if busybox was found
184     wget_opts="$(busybox_filter_wget_options ${WGET_FETCH_OPTIONS})"
185    
186   # install SRCDIR/PNAME if not exist   # install SRCDIR/PNAME if not exist
187   [ ! -d ${SOURCEDIR}/${PNAME} ] && install -d ${SOURCEDIR}/${PNAME}   [ ! -d ${SOURCEDIR}/${PNAME} ] && install -d ${SOURCEDIR}/${PNAME}
188    
189   # check if FETCHING is needed   # check if FETCHING is needed
190   ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} &> /dev/null )   ( cd ${SOURCEDIR}/${PNAME}; md5sum -c ${DB_MD5_SUM_FILE} &> /dev/null )
191   if [[ $? = 0 ]]   if [[ $? = 0 ]]
192   then   then
193   # md5's ok, no fetching needed   # md5's ok, no fetching needed
# Line 171  download_sources() Line 212  download_sources()
212   my_SOURCEDIR="${SOURCEDIR}/${PNAME}"   my_SOURCEDIR="${SOURCEDIR}/${PNAME}"
213   fi   fi
214    
215     # create the SOURCEDIR
216     install -d ${my_SOURCEDIR}
217    
218   # if an mirrored file than replace first the mirror uri   # if an mirrored file than replace first the mirror uri
219   if [[ -n $(echo ${my_SRC_URI} | grep 'mirror://') ]]   if [[ -n $(echo ${my_SRC_URI} | grep 'mirror://') ]]
220   then   then
# Line 182  download_sources() Line 226  download_sources()
226   then   then
227   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"
228   wget \   wget \
229   --passive-ftp \   ${wget_opts} \
230   --tries 3 \   --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
231   "${my_SRC_URI_MIRROR}"   "${my_SRC_URI_MIRROR}"
232   if [[ $? = 0 ]]   if [[ $? = 0 ]]
233   then   then
# Line 206  download_sources() Line 247  download_sources()
247   then   then
248   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"
249   wget \   wget \
250   --passive-ftp \   ${wget_opts} \
251   --tries 3 \   --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
252   "${my_SRC_URI_MIRROR}"   "${my_SRC_URI_MIRROR}"
253   if [[ $? = 0 ]]   if [[ $? = 0 ]]
254   then   then
# Line 230  download_sources() Line 268  download_sources()
268   then   then
269   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"
270   wget \   wget \
271   --passive-ftp \   ${wget_opts} \
272   --tries 3 \   --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
273   "${my_SRC_URI_MIRROR}"   "${my_SRC_URI_MIRROR}"
274   if [[ $? = 0 ]]   if [[ $? = 0 ]]
275   then   then
# Line 254  download_sources() Line 289  download_sources()
289   then   then
290   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"
291   wget \   wget \
292   --passive-ftp \   ${wget_opts} \
293   --tries 3 \   --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
294   "${my_SRC_URI_MIRROR}"   "${my_SRC_URI_MIRROR}"
295   if [[ $? = 0 ]]   if [[ $? = 0 ]]
296   then   then
# Line 278  download_sources() Line 310  download_sources()
310   then   then
311   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"
312   wget \   wget \
313   --passive-ftp \   ${wget_opts} \
314   --tries 3 \   --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
315   "${my_SRC_URI_MIRROR}"   "${my_SRC_URI_MIRROR}"
316   if [[ $? = 0 ]]   if [[ $? = 0 ]]
317   then   then
# Line 297  download_sources() Line 326  download_sources()
326   then   then
327   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI}${COLDEFAULT}"   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI}${COLDEFAULT}"
328   wget \   wget \
329   --passive-ftp \   ${wget_opts} \
330   --tries 3 \   --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI})" \
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
331   "${my_SRC_URI}"   "${my_SRC_URI}"
332   fi   fi
333   fi   fi
# Line 316  download_sources() Line 342  download_sources()
342   # recheck md5 sums   # recheck md5 sums
343   echo   echo
344   echo -e "${COLBLUE}===${COLGREEN} Checking MD5 sums:${COLDEFAULT}"   echo -e "${COLBLUE}===${COLGREEN} Checking MD5 sums:${COLDEFAULT}"
345   ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} ) || die "md5 failed"   ( cd ${SOURCEDIR}/${PNAME}; md5sum -c ${DB_MD5_SUM_FILE} ) || die "md5 failed"
346   echo   echo
347    
348   # not needed anymore   # not needed anymore
# Line 362  mconfigure() Line 388  mconfigure()
388   ./configure \   ./configure \
389   --prefix=/usr \   --prefix=/usr \
390   --host=${CHOST} \   --host=${CHOST} \
391     --build=${CHOST} \
392   --mandir=/usr/share/man \   --mandir=/usr/share/man \
393   --infodir=/usr/share/info \   --infodir=/usr/share/info \
394   --datadir=/usr/share \   --datadir=/usr/share \
# Line 439  munpack() Line 466  munpack()
466   popd > /dev/null   popd > /dev/null
467   fi   fi
468   ;;   ;;
469   tbz2)   xz)
470     IFTAR="$(basename $SRCFILE .xz)"
471     IFTAR="${IFTAR##*.}"
472     if [[ ${IFTAR} = tar ]]
473     then
474     tar --no-same-owner -xvJf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.xz unpack failed."
475     else
476     pushd ${DEST} > /dev/null
477     xzcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .xz) || die ".xz unpack failed."
478     popd > /dev/null
479     fi
480     ;;
481     tbz2|mpks|mpk)
482   tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tbz2 unpack failed."   tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tbz2 unpack failed."
483   ;;   ;;
484   tgz)   tgz)
485   tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tgz unpack failed."   tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tgz unpack failed."
486   ;;   ;;
487     txz|mpkzs|mpkz)
488     tar --no-same-owner -xvJf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".txz unpack failed."
489     ;;
490   rar)   rar)
491   unrar x ${SOURCEDIR}/${PNAME}/${SRCFILE} ${DEST}  || die ".rar unpack failed."   unrar x ${SOURCEDIR}/${PNAME}/${SRCFILE} ${DEST}  || die ".rar unpack failed."
492   ;;   ;;
493   zip)   zip|xpi)
494   unzip ${SOURCEDIR}/${PNAME}/${SRCFILE} -d ${DEST} || die ".zip unpack failed."   unzip ${SOURCEDIR}/${PNAME}/${SRCFILE} -d ${DEST} || die ".zip unpack failed."
495   ;;   ;;
496   rpm)   rpm)
497   pushd ${BUILDDIR} > /dev/null   pushd ${DEST} > /dev/null
498   rpm2targz ${SOURCEDIR}/${PNAME}/${SRCFILE} || die "rpm2targz: .rpm unpack failed."   rpm2targz ${SOURCEDIR}/${PNAME}/${SRCFILE} || die "rpm2targz: .rpm unpack failed."
499   tar --no-same-owner -xvzf ${SRCFILE/.rpm/.tar.gz/} || die "tar: .rpm unpack failed."   tar --no-same-owner -xvzf ${SRCFILE/.rpm/.tar.gz} || die "tar: .rpm unpack failed."
500   [[ -f ${BUILDDIR}/${SRCFILE/.rpm/.tar.gz/} ]] && rm ${BUILDDIR}/${SRCFILE/.rpm/.tar.gz/}   if [[ -f ${DEST}/${SRCFILE/.rpm/.tar.gz} ]]
501     then
502     rm ${DEST}/${SRCFILE/.rpm/.tar.gz}
503     fi
504   ;;   ;;
505   *)   *)
506   die "munpack failed"   die "munpack failed"
# Line 495  mpatch() Line 540  mpatch()
540  mlibtoolize()  mlibtoolize()
541  {  {
542   local opts="$@"   local opts="$@"
543   [[ -z ${opts} ]] && opts="--copy --force"   [[ -z ${opts} ]] && opts="--verbose --install --force"
544    
545   libtoolize ${opts} || die "running: mlibtoolize ${opts}"   libtoolize ${opts} || die "running: mlibtoolize ${opts}"
546  }  }
547    
548    mautoreconf()
549    {
550     local opts="$@"
551     [[ -z ${opts} ]] && opts="--verbose --install --force"
552    
553     autoreconf ${opts} || die "running: mautoreconf ${opts}"
554    }
555    
556  minstalldocs()  minstalldocs()
557  {  {
558   local docfiles   local docfiles
# Line 510  minstalldocs() Line 563  minstalldocs()
563   install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."   install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."
564   fi   fi
565    
566     local i
567   for i in ${docfiles}   for i in ${docfiles}
568   do   do
569   cat ${i} | gzip -9c > ${i}.gz || die "gzipping docs."   if [ -f ${i} ]
570   install -m 0644 ${SRCDIR}/${i}.gz \   then
571   ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "coping docs."   cat ${i} | gzip -9c > ${i}.gz || die "gzipping docs."
572     install -m 0644 ${SRCDIR}/${i}.gz \
573     ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "coping docs."
574     fi
575   done   done
576  }  }
577    
# Line 523  mstriplibs() Line 580  mstriplibs()
580   local stripdir="$@"   local stripdir="$@"
581    
582   [ -z "${stripdir}" ] && stripdir=${BINDIR}   [ -z "${stripdir}" ] && stripdir=${BINDIR}
583   find ${stripdir} | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null   find ${stripdir} | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip ${STRIP_DYN_LIB} 2> /dev/null
584  }  }
585    
586  mstripbins()  mstripbins()
# Line 531  mstripbins() Line 588  mstripbins()
588   local stripdir="$@"   local stripdir="$@"
589    
590   [ -z "${stripdir}" ] && stripdir=${BINDIR}   [ -z "${stripdir}" ] && stripdir=${BINDIR}
591   find ${stripdir} | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null   find ${stripdir} | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip ${STRIP_DYN_BIN} 2> /dev/null
592    }
593    
594    mstripstatic()
595    {
596     local stripdir="$@"
597    
598     [ -z "${stripdir}" ] && stripdir=${BINDIR}
599     find ${stripdir} | xargs file | grep "ar archive" | cut -f 1 -d : | xargs strip ${STRIP_STATIC_LIB} 2> /dev/null
600    }
601    
602    mcompressdocs()
603    {
604     local bindir="$@"
605    
606     if [ -d ${bindir}/usr/share/man ]
607     then
608     echo -e "${COLBLUE}===${COLGREEN} compressing man-pages ...${COLDEFAULT}"
609     ${MLIBDIR}/compressdoc -g -9 ${bindir}/usr/share/man
610     fi
611    
612     if [ -d ${bindir}/usr/share/info ]
613     then
614     echo -e "${COLBLUE}===${COLGREEN} compressing info-pages ...${COLDEFAULT}"
615     ${MLIBDIR}/compressdoc -g -9 ${bindir}/usr/share/info
616     fi
617  }  }
618    
619  sminclude()  sminclude()
# Line 647  EOF Line 729  EOF
729  # special tags:  # special tags:
730  #   PKGTYPE               type of pkg  #   PKGTYPE               type of pkg
731  #   INHERITS              which functions get included  #   INHERITS              which functions get included
732  #   SPECIAL_FUNCTIONS     special functions wich should also be added  #   SPECIAL_FUNCTIONS     special functions which should also be added
733  #                         warning: they get killed before the build starts !  #                         warning: they get killed before the build starts !
734    #   SPLIT_PACKAGES        names of all subpackages which are splitted from parent
735    #   SPLIT_PACKAGE_BASE    base package name for splitpackages
736    #                         (only in the resulting magefile}
737  #  #
738  #   MAGE_TREE_DEST        target destination of the generated tree  #   MAGE_TREE_DEST        target destination of the generated tree
739  #   REGEN_MAGE_TREE       set to 'true' to enable this  #   REGEN_MAGE_TREE       set to 'true' to enable this
# Line 659  build_mage_script() Line 744  build_mage_script()
744   local magefile   local magefile
745   local dest   local dest
746   local target   local target
747     local split_pkg_base
748   local sym   local sym
749   local depname   local depname
750    
# Line 666  build_mage_script() Line 752  build_mage_script()
752   : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}   : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}
753    
754   # determinate which suffix this mage file should get, if any   # determinate which suffix this mage file should get, if any
755   [ -n "$1" ] && target="-$1"   [[ $1 = --target ]] && shift && target="-$1"
756    
757     # mark package as splitpackage
758     [[ $1 = --split-pkg-base ]] && shift && split_pkg_base="$1"
759    
760   # name of magefile   # name of magefile
761   magefile="${PNAME}${target}-${PVER}-${PBUILD}.mage"   magefile="${PNAME}${target}-${PVER}-${PBUILD}.mage"
# Line 682  build_mage_script() Line 771  build_mage_script()
771   # now build the mage file   # now build the mage file
772   > ${dest}   > ${dest}
773    
  # header  
  echo '# $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.59 2007-11-05 16:47:10 niro Exp $' >> ${dest}  
  echo  >> ${dest}  
   
774   # pgkname and state   # pgkname and state
775   echo "PKGNAME=\"${PNAME}${target}-${PVER}-\${ARCH}-${PBUILD}\"" >> ${dest}   echo "PKGNAME=\"${PNAME}${target}-${PVER}-\${ARCH}-${PBUILD}\"" >> ${dest}
776   echo "STATE=\"${STATE}\"" >> ${dest}   echo "STATE=\"${STATE}\"" >> ${dest}
  echo >> ${dest}  
777    
778   # description and homepage   # description and homepage
779   echo "DESCRIPTION=\"${DESCRIPTION}\"" >> ${dest}   echo "DESCRIPTION=\"${DESCRIPTION}\"" >> ${dest}
780   echo "HOMEPAGE=\"${HOMEPAGE}\"" >> ${dest}   echo "HOMEPAGE=\"${HOMEPAGE}\"" >> ${dest}
  echo >> ${dest}  
781    
782   # special tags and vars   # special tags and vars
783   echo "PKGTYPE=\"${PKGTYPE}\""  >> ${dest}   echo "PKGTYPE=\"${PKGTYPE}\""  >> ${dest}
784    
785   # echo MAGE_TARGETS ## note -target is needed !   # echo MAGE_TARGETS ## note -target is needed !
786   echo "MAGE_TARGETS=\"${target}\"" >> ${dest}   echo "MAGE_TARGETS=\"${target}\"" >> ${dest}
787   echo >> ${dest}  
788     # split package base
789     echo "SPLIT_PACKAGE_BASE=\"${split_pkg_base}\"" >> ${dest}
790    
791   # add special vars   # add special vars
792   if [ -n "${SPECIAL_VARS}" ]   if [ -n "${SPECIAL_VARS}" ]
# Line 712  build_mage_script() Line 797  build_mage_script()
797   # being tricky here :)   # being tricky here :)
798   echo "${i}=\"$(eval echo \$${i})\"" >> ${dest}   echo "${i}=\"$(eval echo \$${i})\"" >> ${dest}
799   done   done
  echo  >> ${dest}  
800   fi   fi
801    
802   # add at least all includes   # add at least all includes
# Line 724  build_mage_script() Line 808  build_mage_script()
808   do   do
809   echo -n " ${i}"  >> ${dest}   echo -n " ${i}"  >> ${dest}
810   done   done
811   echo  >> ${dest}   # a CRLF is needed here!
812     echo >> ${dest}
813   fi   fi
  echo >> ${dest}  
814    
815   # deps and provides   # deps and provides
816   echo "DEPEND=\"$(fix_mage_deps "${target}" "${DEPEND}")\"" >> ${dest}   echo "DEPEND=\"$(fix_mage_deps "${target}" "${DEPEND}")\"" >> ${dest}
  echo >> ${dest}  
817   echo "SDEPEND=\"$(fix_mage_deps "${target}" "${SDEPEND}")\"" >> ${dest}   echo "SDEPEND=\"$(fix_mage_deps "${target}" "${SDEPEND}")\"" >> ${dest}
  echo >> ${dest}  
818   echo "PROVIDE=\"${PROVIDE}\"" >> ${dest}   echo "PROVIDE=\"${PROVIDE}\"" >> ${dest}
  echo >> ${dest}  
819    
820   # add special functions   # add special functions
821   if [ -n "${SPECIAL_FUNCTIONS}" ]   if [ -n "${SPECIAL_FUNCTIONS}" ]
# Line 744  build_mage_script() Line 825  build_mage_script()
825   do   do
826   # add to mage (quotes needed !)   # add to mage (quotes needed !)
827   typeset -f "${i}" >> ${dest}   typeset -f "${i}" >> ${dest}
  echo >> ${dest}  
828   # unset to be safe (quotes needed !)   # unset to be safe (quotes needed !)
829   #unset "${i}" <-- later to get every target built   #unset "${i}" <-- later to get every target built
830   done   done
  echo  >> ${dest}  
831   fi   fi
832    
833   # pre|post-install|removes   # pre|post-install|removes
834   typeset -f preinstall >> ${dest}   typeset -f preinstall >> ${dest}
  echo  >> ${dest}  
835   typeset -f postinstall >> ${dest}   typeset -f postinstall >> ${dest}
  echo  >> ${dest}  
836   typeset -f preremove >> ${dest}   typeset -f preremove >> ${dest}
  echo  >> ${dest}  
837   typeset -f postremove >> ${dest}   typeset -f postremove >> ${dest}
  echo  >> ${dest}  
838  }  }
839    
840  regen_mage_tree()  regen_mage_tree()
841  {  {
842   local i   local subpackage
843    
844   # build them only if requested   # build them only if requested
845   if [[ ${REGEN_MAGE_TREE} = true ]]   if [[ ${REGEN_MAGE_TREE} = true ]]
846   then   then
847   # run it without targets   # run it without targets
848   if [ -z "${MAGE_TARGETS}" ]   if [[ -n ${MAGE_TARGETS} ]]
849   then   then
850     # build for each target a mage file
851     # run it with several targets
852   echo   echo
853   build_mage_script   for subpackage in ${MAGE_TARGETS}
854     do
855     build_mage_script --target "${subpackage}"
856     done
857   echo   echo
  else  
858    
859   # build for each target an mage file   # run it for splitpackages
860     elif [[ -n ${SPLIT_PACKAGES} ]]
861     then
862     local split_pkg_base="${PNAME}"
863     # save smage environment
864     split_save_variables
865     # build for each subpackage a mage file
866   # run it with several targets   # run it with several targets
867   for i in ${MAGE_TARGETS}   echo
868     for subpackage in ${SPLIT_PACKAGES}
869   do   do
870   echo   # get the right variables for the split
871   build_mage_script "${i}"   export PNAME="${subpackage}"
872   echo   split_info_${subpackage}
873     # get the preinstall etc
874     split_export_inherits ${subpackage}
875     build_mage_script --split-pkg-base "${split_pkg_base}"
876     # delete split preinstall etc
877     split_delete_inherits ${subpackage}
878     # restore smage environment
879     split_restore_variables
880   done   done
881     echo
882     # unset all saved smage variables
883     split_unset_variables
884    
885     else
886     echo
887     build_mage_script
888     echo
889   fi   fi
890   fi   fi
891    
# Line 815  regen_mage_tree() Line 916  regen_mage_tree()
916   unset postremove   unset postremove
917  }  }
918    
919    split_save_variables()
920    {
921     export SAVED_PNAME="${PNAME}"
922     export SAVED_PVER="${PVER}"
923     export SAVED_PBUILD="${PBUILD}"
924     export SAVED_PCATEGORIE="${PCATEGORIE}"
925     export SAVED_DESCRIPTION="${DESCRIPTION}"
926     export SAVED_HOMEPAGE="${HOMEPAGE}"
927     export SAVED_SPECIAL_VARS="${SPECIAL_VARS}"
928     export SAVED_STATE="${STATE}"
929     export SAVED_PKGTYPE="${PKGTYPE}"
930     export SAVED_INHERITS="${INHERITS}"
931     export SAVED_DEPEND="${DEPEND}"
932     export SAVED_SDEPEND="${SDEPEND}"
933     export SAVED_PROVIDE="${PROVIDE}"
934     export SAVED_NOPKGBUILD="${NOPKGBUILD}"
935    
936     # bindir too
937     export SAVED_BINDIR="${BINDIR}"
938    
939     # export the SPLIT_PACKAGE_BASE
940     export SPLIT_PACKAGE_BASE="${SAVED_PNAME}"
941    
942     # functions
943     if [[ ! -z $(typeset -f preinstall) ]]
944     then
945     # rename the old one
946     local saved_preinstall
947     saved_preinstall=SAVED_$(typeset -f preinstall)
948     eval "${saved_preinstall}"
949     export -f SAVED_preinstall
950     fi
951    
952     if [[ ! -z $(typeset -f postinstall) ]]
953     then
954     # rename the old one
955     local saved_postinstall
956     saved_postinstall=SAVED_$(typeset -f postinstall)
957     eval "${saved_postinstall}"
958     export -f SAVED_postinstall
959     fi
960    
961     if [[ ! -z $(typeset -f preremove) ]]
962     then
963     # rename the old one
964     local saved_preremove
965     saved_preremove=SAVED_$(typeset -f preremove)
966     eval "${saved_preremove}"
967     export -f SAVED_preremove
968     fi
969    
970     if [[ ! -z $(typeset -f postremove) ]]
971     then
972     # rename the old one
973     local saved_postremove
974     saved_postremove=SAVED_$(typeset -f postremove)
975     eval "${saved_postremove}"
976     export -f SAVED_postremove
977     fi
978    }
979    
980    split_restore_variables()
981    {
982     export PNAME="${SAVED_PNAME}"
983     export PVER="${SAVED_PVER}"
984     export PBUILD="${SAVED_PBUILD}"
985     export PCATEGORIE="${SAVED_PCATEGORIE}"
986     export DESCRIPTION="${SAVED_DESCRIPTION}"
987     export HOMEPAGE="${SAVED_HOMEPAGE}"
988     export SPECIAL_VARS="${SAVED_SPECIAL_VARS}"
989     export STATE="${SAVED_STATE}"
990     export PKGTYPE="${SAVED_PKGTYPE}"
991     export INHERITS="${SAVED_INHERITS}"
992     export DEPEND="${SAVED_DEPEND}"
993     export SDEPEND="${SAVED_SDEPEND}"
994     export PROVIDE="${SAVED_PROVIDE}"
995     export NOPKGBUILD="${SAVED_NOPKGBUILD}"
996    
997     # bindir too
998     export BINDIR="${SAVED_BINDIR}"
999    
1000     # functions
1001     if [[ ! -z $(typeset -f SAVED_preinstall) ]]
1002     then
1003     # rename the old one
1004     local saved_preinstall
1005     saved_preinstall=$(typeset -f SAVED_preinstall)
1006     eval "${saved_preinstall/SAVED_/}"
1007     export -f preinstall
1008     fi
1009    
1010     if [[ ! -z $(typeset -f SAVED_postinstall) ]]
1011     then
1012     # rename the old one
1013     local saved_postinstall
1014     saved_postinstall=$(typeset -f SAVED_postinstall)
1015     eval "${saved_postinstall/SAVED_/}"
1016     export -f postinstall
1017     fi
1018    
1019     if [[ ! -z $(typeset -f SAVED_preremove) ]]
1020     then
1021     # rename the old one
1022     local saved_preremove
1023     saved_preremove=$(typeset -f SAVED_preremove)
1024     eval "${saved_preremove/SAVED_/}"
1025     export -f preremove
1026     fi
1027    
1028     if [[ ! -z $(typeset -f SAVED_postremove) ]]
1029     then
1030     # rename the old one
1031     local saved_postremove
1032     saved_postremove=$(typeset -f SAVED_postremove)
1033     eval "${saved_postremove/SAVED_/}"
1034     export -f postremove
1035     fi
1036    }
1037    
1038    split_unset_variables()
1039    {
1040     # unset saved vars; not needed anymore
1041     unset SAVED_PNAME
1042     unset SAVED_PVER
1043     unset SAVED_PBUILD
1044     unset SAVED_PCATEGORIE
1045     unset SAVED_DESCRIPTION
1046     unset SAVED_HOMEPAGE
1047     unset SAVED_SPECIAL_VARS
1048     unset SAVED_STATE
1049     unset SAVED_PKGTYPE
1050     unset SAVED_INHERITS
1051     unset SAVED_DEPEND
1052     unset SAVED_SDEPEND
1053     unset SAVED_PROVIDE
1054     unset SAVED_BINDIR
1055     unset SAVED_NOPKGBUILD
1056     unset SPLIT_PACKAGE_BASE
1057     unset -f SAVED_preinstall
1058     unset -f SAVED_postinstall
1059     unset -f SAVED_preremove
1060     unset -f SAVED_postremove
1061    }
1062    
1063    split_export_inherits()
1064    {
1065     local subpackage="$1"
1066     local func
1067     local newfunc
1068    
1069     for func in preinstall postinstall preremove postremove
1070     do
1071     if [[ ! -z $(typeset -f ${func}_${subpackage}) ]]
1072     then
1073     newfunc=$(typeset -f ${func}_${subpackage})
1074     newfunc="${newfunc/_${subpackage} (/ (}"
1075     eval "${newfunc}"
1076     fi
1077     done
1078    }
1079    
1080    split_delete_inherits()
1081    {
1082     local subpackage="$1"
1083     local func
1084    
1085     for func in preinstall postinstall preremove postremove
1086     do
1087     if [[ ! -z $(typeset -f ${func}_${subpackage}) ]]
1088     then
1089     unset -f ${func}
1090     fi
1091     done
1092     }
1093    
1094  export_inherits()  export_inherits()
1095  {  {
1096   local include="$1"   local include="$1"
# Line 876  generate_package_md5sum() Line 1152  generate_package_md5sum()
1152   # fix target as it may be empty !   # fix target as it may be empty !
1153   [ -n "${target}" ] && target="-${target}"   [ -n "${target}" ] && target="-${target}"
1154    
1155    
1156   # build pkgname   # build pkgname
1157   pkgname="${pname}${target}-${pver}-${parch}-${pbuild}"   pkgname="${pname}${target}-${pver}-${parch}-${pbuild}"
1158    
# Line 895  generate_package_md5sum() Line 1172  generate_package_md5sum()
1172   : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}   : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}
1173    
1174   # setup md5 dir   # setup md5 dir
1175   dest="${MAGE_TREE_DEST}/${pcat}/${pname}/md5"   dest="${MAGE_TREE_DEST}/${pcat}/${pname}${target}/md5"
1176   install -d ${dest}   install -d ${dest}
1177    
1178   # gen md5sum   # gen md5sum
# Line 933  source_pkg_build() Line 1210  source_pkg_build()
1210   echo -e "${COLGREEN}Source package ${COLBLUE}${PNAME}-${PVER}-${PBUILD}.${SRCPKGSUFFIX} ${COLGREEN}successfully builded.${COLDEFAULT}"   echo -e "${COLGREEN}Source package ${COLBLUE}${PNAME}-${PVER}-${PBUILD}.${SRCPKGSUFFIX} ${COLGREEN}successfully builded.${COLDEFAULT}"
1211  }  }
1212    
1213    step_by_step()
1214    {
1215     if [[ ${STEP_BY_STEP} = true ]]
1216     then
1217     echo -e "${COLRED}Step-by-step enabled! Paused after $1.${COLDEFAULT}"
1218     echo "Press [enter] to continue"
1219     read
1220     fi
1221    }
1222    
1223    
1224  # print out our version  # print out our version
1225  showversion  showversion
# Line 959  fi Line 1246  fi
1246  # creates md5sums for smages to given dir  # creates md5sums for smages to given dir
1247  if [[ $1 = calcmd5 ]]  if [[ $1 = calcmd5 ]]
1248  then  then
1249   if [ $# -ge 3 ]   if [ $# -ge 2 ]
1250   then   then
1251   SMAGENAME="$2"   SMAGENAME="$2"
1252   MD5DIR="$3"   MD5DIR="$3"
1253   source ${SMAGENAME} || die "download source failed"   [[ -z ${MD5DIR} ]] && MD5DIR="$(dirname ${SMAGENAME})/md5"
1254    
1255     smagesource ${SMAGENAME} || die "download source failed"
1256    
1257   # overridable sourcedir; must be declared after source of the smage2   # overridable sourcedir; must be declared after source of the smage2
1258   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"
# Line 1015  then Line 1304  then
1304   echo   echo
1305   else   else
1306   echo "Usage: Calculating MD5 Sums:"   echo "Usage: Calculating MD5 Sums:"
1307   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME /path/to/MD5DIR"   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME [/path/to/MD5DIR]"
1308   echo   echo
1309   echo   echo
1310   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."
# Line 1037  then Line 1326  then
1326   # get smage   # get smage
1327   SMAGENAME="$2"   SMAGENAME="$2"
1328   MD5DIR="$(dirname ${SMAGENAME})/md5"   MD5DIR="$(dirname ${SMAGENAME})/md5"
1329   source ${SMAGENAME} || die "download source failed"   smagesource ${SMAGENAME} || die "download source failed"
1330    
1331   download_sources   download_sources
1332   exit 0   exit 0
# Line 1049  then Line 1338  then
1338   # set correct SMAGENAME   # set correct SMAGENAME
1339   SMAGENAME="$2"   SMAGENAME="$2"
1340   MD5DIR="$(dirname ${SMAGENAME})/md5"   MD5DIR="$(dirname ${SMAGENAME})/md5"
1341   source ${SMAGENAME} || die "regen: smage2 not found"   smagesource ${SMAGENAME} || die "regen: smage2 not found"
1342    
1343   regen_mage_tree   regen_mage_tree
1344    
1345   # build md5sum for existing packages   # build several targets
1346   generate_package_md5sum \   if [[ -n ${MAGE_TARGETS} ]]
1347   --pcat "${PCATEGORIE}" \   then
1348   --pname "${PNAME}" \   for target in ${MAGE_TARGETS}
1349   --pver "${PVER}" \   do
1350   --pbuild "${PBUILD}" \   # build md5sum for existing packages
1351   --parch "${ARCH}" \   generate_package_md5sum \
1352   --target "${target}"   --pcat "${PCATEGORIE}" \
1353     --pname "${PNAME}" \
1354     --pver "${PVER}" \
1355     --pbuild "${PBUILD}" \
1356     --parch "${ARCH}" \
1357     --target "${target}"
1358     done
1359    
1360     # build several subpackages
1361     elif [[ -n ${SPLIT_PACKAGES} ]]
1362     then
1363     split_save_variables
1364     for subpackage in ${SPLIT_PACKAGES}
1365     do
1366     # get the right variables for the split
1367     export PNAME="${subpackage}"
1368     split_info_${subpackage}
1369     # build md5sum for existing packages
1370     generate_package_md5sum \
1371     --pcat "${PCATEGORIE}" \
1372     --pname "${PNAME}" \
1373     --pver "${PVER}" \
1374     --pbuild "${PBUILD}" \
1375     --parch "${ARCH}"
1376     # restore smage environment
1377     split_restore_variables
1378     done
1379     # unset all saved smage variables
1380     split_unset_variables
1381    
1382     else
1383     # build md5sum for existing packages
1384     generate_package_md5sum \
1385     --pcat "${PCATEGORIE}" \
1386     --pname "${PNAME}" \
1387     --pver "${PVER}" \
1388     --pbuild "${PBUILD}" \
1389     --parch "${ARCH}"
1390     fi
1391    
1392   exit 0   exit 0
1393  fi  fi
# Line 1073  then Line 1400  then
1400    
1401   echo -e "${COLGREEN}create-src-tarball called for ${COLBLUE}${SMAGENAME}${COLGREEN} ...${COLDEFAULT}"   echo -e "${COLGREEN}create-src-tarball called for ${COLBLUE}${SMAGENAME}${COLGREEN} ...${COLDEFAULT}"
1402    
1403   source ${SMAGENAME} || die "regen: smage2 not found"   smagesource ${SMAGENAME} || die "regen: smage2 not found"
1404    
1405   if [[ -d ${SOURCEDIR}/${PNAME} ]]   if [[ -d ${SOURCEDIR}/${PNAME} ]]
1406   then   then
# Line 1122  fi Line 1449  fi
1449  [ -z "${CFLAGS}" ] && die "no CFLAGS variable found in ${MAGERC}"  [ -z "${CFLAGS}" ] && die "no CFLAGS variable found in ${MAGERC}"
1450  [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"  [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"
1451    
1452  source ${SMAGENAME} || die "source failed"  smagesource ${SMAGENAME} || die "source failed"
1453  PKGNAME="${PNAME}-${PVER}-${ARCH}-${PBUILD}"  PKGNAME="${PNAME}-${PVER}-${ARCH}-${PBUILD}"
1454  MD5DIR="$(dirname ${SMAGENAME})/md5"  MD5DIR="$(dirname ${SMAGENAME})/md5"
1455    SMAGE_LOG_CMD="tee -a /var/log/smage/${PKGNAME}.log"
1456    
1457  xtitle "Compiling ${PKGNAME}"  xtitle "Compiling ${PKGNAME}"
1458  echo -e "${COLGREEN}Compiling ${PKGNAME}${COLDEFAULT}"  echo -e "${COLGREEN}Compiling ${PKGNAME}${COLDEFAULT}"
# Line 1199  then Line 1527  then
1527   mage rmstamp   mage rmstamp
1528  fi  fi
1529    
1530  src_prepare || die "src_prepare failed"  # setup build loggins
1531  src_compile || die "src_compile failed"  [[ ! -d /var/log/smage ]] && install -d /var/log/smage
1532  src_install || die "src_install failed"  echo -e "### Build started on $(date) ###\n" > /var/log/smage/${PKGNAME}.log
1533    
1534    src_prepare | ${SMAGE_LOG_CMD}
1535    die_pipestatus 0 "src_prepare failed"
1536    step_by_step $_
1537    
1538    src_compile | ${SMAGE_LOG_CMD}
1539    die_pipestatus 0 "src_compile failed"
1540    step_by_step $_
1541    
1542  # compressing doc, info & man files  # build several subpackages
1543  if [ -d ${BUILDDIR}/builded/usr/share/man ]  if [[ -n ${SPLIT_PACKAGES} ]]
1544  then  then
1545   echo -e "${COLBLUE}===${COLGREEN} compressing man-pages ...${COLDEFAULT}"   # save bindir & pname
1546   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/man   split_save_variables
1547     export SAVED_BINDIR="${BINDIR}"
1548     for subpackage in ${SPLIT_PACKAGES}
1549     do
1550     if typeset -f src_install_${subpackage} > /dev/null
1551     then
1552     # export subpackage bindir
1553     export BINDIR="${SAVED_BINDIR}_${subpackage}"
1554     # export PNAME, several internal function and include
1555     # rely on this variable
1556     export PNAME="${subpackage}"
1557    
1558     echo
1559     echo -en "${COLBLUE}*** ${COLDEFAULT}"
1560     echo -en "  Running ${COLGREEN}split src_install()${COLDEFAULT}"
1561     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
1562     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
1563    
1564     src_install_${subpackage} | ${SMAGE_LOG_CMD}
1565     die_pipestatus 0 "src_install_${subpackage} failed"
1566     step_by_step $_
1567     fi
1568     done
1569     # restore bindir & pname
1570     split_restore_variables
1571     # unset all saved smage variables
1572     split_unset_variables
1573    else
1574     src_install | ${SMAGE_LOG_CMD}
1575     die_pipestatus 0 "src_install failed"
1576     step_by_step $_
1577  fi  fi
1578    
1579  if [ -d ${BUILDDIR}/builded/usr/share/info ]  # compressing doc, info & man files
1580    if [[ -n ${SPLIT_PACKAGES} ]]
1581  then  then
1582   echo -e "${COLBLUE}===${COLGREEN} compressing info-pages ...${COLDEFAULT}"   for subpackage in ${SPLIT_PACKAGES}
1583   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/info   do
1584     mcompressdocs ${BINDIR}_${subpackage}
1585     done
1586    else
1587     mcompressdocs ${BINDIR}
1588  fi  fi
1589    
1590    
1591  # stripping all bins and libs  # stripping all bins and libs
1592  case ${NOSTRIP} in  case ${NOSTRIP} in
1593   true|TRUE|yes|y)   true|TRUE|yes|y)
1594   echo -e "NOSTRIP=true detected; Package will not be stripped ..."   echo -e "NOSTRIP=true detected; Package will not be stripped ..."
1595   ;;   ;;
1596   *)   *)
1597   echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"   if [[ -n ${SPLIT_PACKAGES} ]]
1598   mstripbins ${BINDIR}   then
1599   echo -e "${COLBLUE}===${COLGREEN} stripping libraries ...${COLDEFAULT}"   for subpackage in ${SPLIT_PACKAGES}
1600   mstriplibs ${BINDIR}   do
1601     echo -e "${COLBLUE}===${COLGREEN} stripping binaries for '${subpackage}' ...${COLDEFAULT}"
1602     mstripbins ${BINDIR}_${subpackage}
1603     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries for '${subpackage}' ...${COLDEFAULT}"
1604     mstriplibs ${BINDIR}_${subpackage}
1605     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries for '${subpackage}' ...${COLDEFAULT}"
1606     mstripstatic ${BINDIR}_${subpackage}
1607     done
1608     else
1609     echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"
1610     mstripbins ${BINDIR}
1611     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries ...${COLDEFAULT}"
1612     mstriplibs ${BINDIR}
1613     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries ...${COLDEFAULT}"
1614     mstripstatic ${BINDIR}
1615     fi
1616   ;;   ;;
1617  esac  esac
1618    
# Line 1237  case ${NOPKGBUILD} in Line 1623  case ${NOPKGBUILD} in
1623   ;;   ;;
1624   *)   *)
1625   # build several targets   # build several targets
1626   if [ -n "${MAGE_TARGETS}" ]   if [[ -n ${MAGE_TARGETS} ]]
1627   then   then
1628   for target in ${MAGE_TARGETS}   for target in ${MAGE_TARGETS}
1629   do   do
# Line 1263  case ${NOPKGBUILD} in Line 1649  case ${NOPKGBUILD} in
1649    
1650   echo -e "${COLGREEN}\nPackage ${PNAME}-${target}-${PVER}-${ARCH}-${PBUILD} successfully builded.\n${COLDEFAULT}"   echo -e "${COLGREEN}\nPackage ${PNAME}-${target}-${PVER}-${ARCH}-${PBUILD} successfully builded.\n${COLDEFAULT}"
1651   done   done
1652    
1653     # build several subpackages
1654     elif [[ -n ${SPLIT_PACKAGES} ]]
1655     then
1656     split_save_variables
1657     for subpackage in ${SPLIT_PACKAGES}
1658     do
1659     # get the right variables for the split
1660     export PNAME="${subpackage}"
1661     split_info_${PNAME}
1662    
1663     # jump to next one if NOPKGBUILD is set in split_info
1664     case ${NOPKGBUILD} in
1665     true|TRUE|yes|y) continue ;;
1666     esac
1667    
1668     # check if an special subpackage_pkgbuild exists
1669     if typeset -f ${PNAME}_pkgbuild > /dev/null
1670     then
1671     # run it
1672     ${PNAME}_pkgbuild
1673     fi
1674     # now create the target package
1675     ${MLIBDIR}/pkgbuild_dir.sh \
1676     "${PNAME}-${PVER}-${ARCH}-${PBUILD}" \
1677     "${BINDIR}_${PNAME}" || die "split_package: ${PNAME} package-build failed"
1678    
1679     # build pkg-md5-sum if requested
1680     generate_package_md5sum \
1681     --pcat "${PCATEGORIE}" \
1682     --pname "${PNAME}" \
1683     --pver "${PVER}" \
1684     --pbuild "${PBUILD}" \
1685     --parch "${ARCH}"
1686    
1687     echo -e "${COLGREEN}\nPackage ${PNAME}-${PVER}-${ARCH}-${PBUILD} successfully builded.\n${COLDEFAULT}"
1688    
1689     # restore smage environment
1690     split_restore_variables
1691     done
1692     # unset all saved smage variables
1693     split_unset_variables
1694    
1695   else   else
1696   ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"   ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"
1697    
# Line 1282  case ${NOPKGBUILD} in Line 1711  case ${NOPKGBUILD} in
1711   ;;   ;;
1712  esac  esac
1713    
1714    if [[ ${SMAGE_BUILD_LOGGING} != false ]]
1715    then
1716     bzip2 -9f /var/log/smage/${PKGNAME}.log
1717    else
1718     [[ -f /var/log/smage/${PKGNAME}.log ]] && rm /var/log/smage/${PKGNAME}.log
1719    fi
1720    
1721  # for sure  # for sure
1722  unset NOPKGBUILD  unset NOPKGBUILD
1723  unset NOSTRIP  unset NOSTRIP

Legend:
Removed from v.597  
changed lines
  Added in v.1571